﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals

	Public ABM As ABMaterial
	Public ABMComp As ABMCustomComponent
	
	Private Parent_Page As ABMPage
	Private Parent_Instance_Name As String

	Public BorderColor As String
	Public BorderIntensity As String
	Public BorderStyle As String
	Public BorderWidth As String
	Public BorderRadius As String
	Public PaddingBottom As String
	Public PaddingLeft As String
	Public PaddingRight As String
	Public PaddingTop As String
	Public ZDepth As String
	
End Sub

Public Sub Initialize(Passed_Page As ABMPage, Passed_Instance_Name As String)
	
	Parent_Page = Passed_Page
	
	Parent_Instance_Name = Passed_Instance_Name.ToLowerCase
	
	'Set property defaults
	BorderColor = ABM.COLOR_LIGHTBLUE
	BorderIntensity = ABM.INTENSITY_NORMAL
	BorderStyle = ABM.BORDER_NONE
	BorderWidth = "0px"
	BorderRadius = "0px"
	PaddingBottom = "0px"
	PaddingLeft = "0px"
	PaddingRight = "0px"
	PaddingTop = "0px"
	ZDepth = ABM.ZDEPTH_1

	ABMComp.Initialize("ABMComp", Me, Parent_Page, Parent_Instance_Name, "")
	
End Sub

Sub ABMComp_Build(Passed_page As ABMPage, Passed_Instance_Name As String) As String
	
	'Passed_page is just Parent_page
	'Passed_Instance_Name is just Parent_Instance_Name

	Private cookie_div_css As String

	If PaddingTop <> "" Then cookie_div_css = cookie_div_css & "padding-top: " & PaddingTop & ";"
	If PaddingBottom <> "" Then cookie_div_css = cookie_div_css & "padding-bottom: " & PaddingBottom & ";"
	If PaddingLeft <> "" Then cookie_div_css = cookie_div_css & "padding-left: " & PaddingLeft & ";"
	If PaddingRight <> "" Then cookie_div_css = cookie_div_css & "padding-right: " & PaddingRight & ";"
	If ZDepth <> "" Then cookie_div_css = cookie_div_css & ZDepth & ";"
	cookie_div_css = cookie_div_css & "width:100%;height:100%" & _
	              ";background:#ffffff;border-radius:0px;"

	Private div_str As String

	div_str = $"
<div id="cookie_div" style="${cookie_div_css}">
    <style>
        #cookie_message1 {
            position: absolute;
            top: 10vh;
            left: 0;
            width: 100%;
            height: 100%;
            display: flex;
            align-items: center;
            justify-content: center;
            background-color: rgba(0, 0, 0, 0.0);
            color: red;
            font-size: min(calc(0rem + 5vw), calc(0rem + 5vh)); /* Adjust scaling as needed -
                                                                   1rem is base font size (which is
                                                                   typically equivalent to 16px), 
                                                                   5vw means 5% of viewport width
                                                                   5vh means 5% of viewport height) */
            text-align: center;
            font-weight: bold;
            padding-top: calc(${PaddingTop} + 10vh);
            padding-right: calc(${PaddingRight} + 10vw);
            padding-bottom: calc(${PaddingBottom} + 10vh);
            padding-left: calc(${PaddingLeft} + 10vw);
        }
        #cookie_message2 {
            position: absolute;
            top: 30vh;
            left: 0;
            width: 100%;
            height: 100%;
            display: flex;
            align-items: center;
            justify-content: center;
            background-color: rgba(0, 0, 0, 0.0);
            color: red;
            font-size: min(calc(0rem + 5vw), calc(0rem + 5vh)); /* Adjust scaling as needed -
                                                                   1rem is base font size (which is
                                                                   typically equivalent to 16px), 
                                                                   5vw means 5% of viewport width
                                                                   5vh means 5% of viewport height) */
            text-align: center;
            font-weight: bold;
            padding-top: calc(${PaddingTop} + 10vh);
            padding-right: calc(${PaddingRight} + 10vw);
            padding-bottom: calc(${PaddingBottom} + 10vh);
            padding-left: calc(${PaddingLeft} + 10vw);
        }
    </style>
    <div id="cookie_message1">
        Tap anywhere here to check if 1st party cookies are enabled, add a cookie and report on cookies present (see log)
    </div>
    <div id="cookie_message2">
        Tap anywhere here to delete any and all cookies
    </div>
</div>
"$

	Log("<<<<<<<< ABMComp_Build " & div_str)
    
    Return div_str
    
End Sub

Sub ABMComp_FirstRun(Passed_page As ABMPage, Passed_Instance_Name As String)
    
    'Passed_page is just Parent_page
    'Passed_Instance_Name is just Parent_Instance_Name
    
End Sub

Sub ABMComp_Refresh(Passed_page As ABMPage, Passed_Instance_Name As String)
    
	'Passed_page is just Parent_page
	'Passed_Instance_Name is just Parent_Instance_Name

	Private script_str As String = $"
function handlecookiemessage1() {

    let date = new Date();
    date.setDate(date.getDate() + 30);
    let day = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"][date.getUTCDay()];
    let dateNum = String(date.getUTCDate()).padStart(2, '0');
    let month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"][date.getUTCMonth()];
    let year = date.getUTCFullYear();
    let hours = String(date.getUTCHours()).padStart(2, '0');
    let minutes = String(date.getUTCMinutes()).padStart(2, '0');
    let seconds = String(date.getUTCSeconds()).padStart(2, '0');
    let formattedDate = day + ', ' + dateNum + '-' + month + '-' + year + ' ' + hours + ':' + minutes + ':' + seconds + ' UTC';
    let ticks = date.getTime();
    b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': formattedDate});

    var userAgent = window.navigator.userAgent;
    b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': userAgent});
    if (userAgent.match(/iPad|iPhone/i)) {
        // User is on iPad or iPhone
        try {
            document.cookie = 'cookietest=1';
            const isCookieEnabled = document.cookie.indexOf('cookietest=') !== -1;
            document.cookie = 'cookietest=1; expires=Thu, 01-Jan-1970 00:00:01 GMT';
            if (isCookieEnabled) {
                b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "iOS, 1st party cookies enabled"});
            } else {
                b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "iOS, 1st party cookies blocked"});
				return;
            }
        } catch (e) {
            b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "iOS false"});
			return;
        }
		document.cookie = 'Cookie_iOS_secure' + ticks + '=abcxyz/expiry=' + formattedDate + '; expires=' + formattedDate + '; Secure';
		document.cookie = 'Cookie_iOS_unsecure' + ticks + '=abcxyz/expiry=' + formattedDate + '; expires=' + formattedDate;
    } else if (userAgent.match(/Android/i)) {
        // User is on Android
        const isCookieEnabled = navigator.cookieEnabled;
        if (isCookieEnabled) {
            b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "Android, 1st party cookies enabled"});
        } else {
            b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "Android, 1st party cookies blocked"});
			return;
        }
		document.cookie = 'Cookie_Android_secure' + ticks + '=abcxyz/expiry=' + formattedDate + '; expires=' + formattedDate + '; Secure';
		document.cookie = 'Cookie_Android_unsecure' + ticks + '=abcxyz/expiry=' + formattedDate + '; expires=' + formattedDate;
    } else {
        const isCookieEnabled = navigator.cookieEnabled;
        if (isCookieEnabled) {
            b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "Neither iPhone nor Android, 1st party cookies enabled"});
        } else {
            b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "Android, 1st party cookies blocked"});
			return;
        }
        b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "Neither iPhone nor Android"});
		document.cookie = 'Cookie_Neither_secure' + ticks + '=abcxyz/expiry=' + formattedDate + '; expires=' + formattedDate + '; Secure';
		document.cookie = 'Cookie_Neither_unsecure' + ticks + '=abcxyz/expiry=' + formattedDate + '; expires=' + formattedDate;
	}
	b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': document.cookie});
}

// Run handlecookiemessage1 once when JavaScript is defined
handlecookiemessage1();

// Run handlecookiemessage1 when cookie_message1 is clicked
var cookie_message1 = document.getElementById('cookie_message1');
cookie_message1.addEventListener('click', handlecookiemessage1);	

var cookie_message2 = document.getElementById('cookie_message2');
cookie_message2.addEventListener('click', function() {

	b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': " "});
	b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "Cookies to be deleted:"});
	b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': document.cookie});
    var cookies = document.cookie.split(";");
    for (var i = 0; i < cookies.length; i++) {
        var cookie = cookies[i];
        var eqPos = cookie.indexOf("=");
        var name = eqPos > -1 ? cookie.substr(0, eqPos) : cookie;
        document.cookie = name + "=;expires=Thu, 01 Jan 1970 00:00:00 GMT";
    }
	b4j_raiseEvent('${Passed_Instance_Name}_Report', {'value': "Cookies deleted"});
	
});
"$    

	Log(script_str)
    
	Parent_Page.ws.Eval(script_str, Array As Object(Passed_Instance_Name))
	
End Sub

Sub ABMComp_CleanUp(Passed_page As ABMPage, Passed_Instance_Name As String)
	
	'Passed_page is just Parent_page
	'Passed_Instance_Name is just Parent_Instance_Name
	
End Sub
