﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
Sub Class_Globals

	Private ABM As ABMaterial
	
	Public Page As ABMPage
	
	'Browsers unique page id
	Private PageID As String = ""
	
	'Page name, must be same as this class name (case sensitive!)
	Public PageName As String = "Cookie_4_ABM_Page"  '<---- IMPORTANT
	
	Private ws As WebSocket
	
	Private Cookie_4_ABM_Instance As Cookie_4_ABM_Object
	
End Sub

Public Sub Initialize
	
	'Initialize page
	Page.Initialize(PageName, "/ws/" & Main.Server.AppName & "/" & PageName, False, Main.Server.SessionMaxInactiveIntervalSeconds)
	Page.ShowLoader=True
	Page.PageHTMLName = "index.html"
	Page.PageTitle = "Cookie_4_ABM"
	Page.PageDescription = "Cookie_4_ABM"
	Page.PageKeywords = ""
	Page.PageSiteMapPriority = ""
	Page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_YEARLY
		
	'Green dot in top RH corner => connected, red dot => not connected
	Page.ShowConnectedIndicator = True

	'Create page grid - 1 row x 1 column
	Page.AddRowsM2(1, False, 0, 0, 0, 0, "").AddCells12MP(1, 0, 0, 0, 0, "")
	Page.BuildGrid 
	
	'Initialize instance of Cookie_4_ABM_Object,
	'Passed_Instance_Name = name of this instance
	Cookie_4_ABM_Instance.Initialize(Page, "Cookie_4_ABM_Instance")

	'See Cookie_4_ABM_Object.Initialize for defaults which
	'can be overidden here, for example:
'	Cookie_4_ABM_Instance.BorderColor = ABM.COLOR_BLUE
'	Cookie_4_ABM_Instance.BorderIntensity = ABM.INTENSITY_DARKEN2
'	Cookie_4_ABM_Instance.BorderStyle = ABM.BORDER_SOLID
'	Cookie_4_ABM_Instance.BorderWidth = "10px"
'	Cookie_4_ABM_Instance.Borderradius = "10px"
'	Cookie_4_ABM_Instance.PaddingBottom = "10px"
'	Cookie_4_ABM_Instance.PaddingLeft = "10px"
'	Cookie_4_ABM_Instance.PaddingRight = "10px"
'	Cookie_4_ABM_Instance.PaddingTop = "10px"
'	Cookie_4_ABM_Instance.ZDepth = ABM.ZDEPTH_REMOVE

	Page.Cell(1,1).AddComponent(Cookie_4_ABM_Instance.ABMComp)
	
End Sub

Private Sub WebSocket_Connected(WebSocket1 As WebSocket)
	
	ws = WebSocket1	
	
	'This avoids error
	'    org.eclipse.jetty.websocket.api.exceptions.MessageTooLargeException: Text message too large: (actual) 66,704 > (configured max text message size) 65,536
	'when taking a picture, see:
	'    https://www.b4x.com/android/forum/threads/webapp-jetty-how-to-use-setmaxtextmessagesize.45644/post-983937
	'need to make wssize larger than max resolution of largest
	'screen expected to encounter - note screen, not camera
	Private wssize As Long = 4 * 1024 * 1024
	Private wrk_jo As JavaObject = ws
	wrk_jo = wrk_jo.GetFieldJO("session").RunMethod("getPolicy", Null)
	wrk_jo.RunMethod("setMaxTextMessageSize", Array(wssize))
	
	PageID = ABM.GetPageID(Page, PageName, ws)
	
	Main.Server.Connected(Me, ws, Page, PageID)
	
'	Log("Connected: " & PageID)
	
End Sub

Private Sub WebSocket_Disconnected
	
'	Log("Disconnected: " & PageID)
	
	Main.Server.Disconnected(ws)
	
End Sub

Sub Page_ParseEvent(Params As Map)
	
	Main.Server.Page_ParseEvent(Me, Page, PageID, Params)
	
End Sub

'MUST be here
Public Sub ConnectPage()
	
	'Refresh page
	Page.Refresh	
	
	'Tell browser finished loading
	Page.FinishedLoading
	
End Sub

Sub Cookie_4_ABM_Instance_Report(value As Map)
	
	Private wrk_out As String = value.GetDefault("value", "")

	'If reporting on cookies...
	If wrk_out.Contains("Cookie_Android") Or wrk_out.Contains("Cookie_iOS") Or wrk_out.Contains("Cookie_Neither") Then

		Private wrk_cookies() As String
		wrk_cookies = Regex.Split(";", wrk_out)
		
		Private wrk_ptr As Int
		
		For wrk_ptr = 0 To wrk_cookies.Length - 1 
			Log("Report: " & wrk_cookies(wrk_ptr).Trim)
		Next
		
	'Otherwise...
	Else
		
		Log("Report: " & wrk_out)
	
	End If
	
End Sub
